#################################
##\umpgbNAv
#################################

######################################
## old-faithful data
# eruptions: Ԍ򂪕o܂łɊ| ()
# waiting: ̐o܂ł̎
library(FNN)

# f[^̓ǂݍ
oldfaithful.data <- read.table(file = "oldfaithfuldata.txt",header=TRUE)
attach(oldfaithful.data)

## Nadaraya-Watson
# ftHg̐ݒNadaraya-Watson (h=0.5)
oldfaithful.reg.default <- ksmooth(eruptions, waiting, kernel="normal")
plot(eruptions, waiting); lines(oldfaithful.reg.default)

# a smaller bandwidth (h=0.1)
oldfaithful.reg.smallbw <- ksmooth(eruptions, waiting, kernel="normal", bandwidth=0.1); 
lines(oldfaithful.reg.smallbw,col='2')  #ǂ茋ʂƂ͌ɂ

# A larger bandwidth (h=2)
oldfaithful.reg.largebw <- ksmooth(eruptions, waiting, kernel="normal", bandwidth=2); 
lines(oldfaithful.reg.largebw,col='3')  #Ȃ

## lm, `A
oldfaithful.lm <- lm(waiting ~ eruptions)
plot(eruptions, waiting); lines(eruptions,predict(oldfaithful.lm))

## knn
# k=50
oldfaithful.knn <- knn.reg(eruptions,y=waiting,k=50)
sind = order(eruptions)
plot(eruptions, waiting); lines(eruptions[sind],oldfaithful.knn$pred[sind],col='2')

# k=5
oldfaithful.knn.smallk <- knn.reg(eruptions,y=waiting,k=5)
lines(eruptions[sind],oldfaithful.knn.smallk$pred[sind],col='3')
legend(-3, 0.5, legend = c("k=50","k=5"), lty = c(1,1), col=c(2,3),title = "k")


# e@r
plot(eruptions, waiting); 
lines(oldfaithful.reg.default,col='2')
lines(oldfaithful.reg.largebw,col='3')
lines(eruptions,predict(oldfaithful.lm),col='4')
lines(eruptions[sind],oldfaithful.knn$pred[sind],col='5')


# estimating the test error
n <- length(eruptions)

err.ks.default <- c(1:10)
err.ks.lw <- c(1:10)
err.knn <- c(1:10)
err.lm <- c(1:10)


for(cv_iter in 1:10){
	indtrain <- sample(n,floor(0.8*n))
	train.erupt <- eruptions[indtrain]
	train.waiting <- waiting[indtrain]
	train = data.frame(erupt = eruptions[indtrain], waiting = waiting[indtrain])
	test = data.frame(erupt = eruptions[-indtrain], waiting = waiting[-indtrain])

	oldfaithful.lm <- lm(waiting ~ erupt, data=train)
	oldfaithful.lm.predict_new <- predict(oldfaithful.lm,test)
	err.lm[cv_iter] = mean((oldfaithful.lm.predict_new - test$waiting)^2)

	oldfaithful.reg.default.pred <- ksmooth(train$erupt,train$waiting, kernel="normal", x.points = test$erupt)
	sind <- order(test$erupt) #ksmooth̗\x̒lɃ\[ĝŁC񂵒D
	err.ks.default[cv_iter] = mean((oldfaithful.reg.default.pred$y - test$waiting[sind ])^2)

	oldfaithful.reg.lw.pred <- ksmooth(train$erupt,train$waiting, kernel="normal", bandwidth=2, x.points = test$erupt)
	err.ks.lw[cv_iter] = mean((oldfaithful.reg.lw.pred$y - test$waiting[sind ])^2)

	oldfaithful.knn <- knn.reg(train=train$erupt,test=as.matrix(test$erupt,ncol=1),y=train$waiting,k=50)
	err.knn[cv_iter] = mean((oldfaithful.knn$pred - test$waiting)^2)
}

c(mean(err.lm),mean(err.ks.lw),mean(err.ks.default),mean(err.knn)) # ǂꂪԗǂł낤H


#####################################
## I]f[^ŃXvC
library("gam") #generalized additive model
library("mgcv") #gam㏑GCVł悤ɂȂD

plot(airquality$Temp,airquality$Ozone)
plot(airquality$Temp,airquality$Ozone^0.1)

lm.model<-gam(Ozone^0.1~Temp,data=airquality)        #@`A
gam.model<-gam(Ozone^0.1~s(Temp),data=airquality)    #@XvC

new<-data.frame(Temp=seq(min(airquality$Temp),max(airquality$Temp),0.1))
lm.pred<-predict(lm.model,new)
gam.pred<-predict(gam.model,new)

plot(airquality$Ozone^0.1~airquality$Temp,xlab="Temp",ylab="Ozone",
    main="茋",cex.main=2,cex.lab=1.5)
lines(lm.pred~as.matrix(new),col=2,lwd=2)
lines(gam.pred~as.matrix(new),col=4,lwd=2)
legend("topleft",lwd=2,col=c(2,4),legend=c("` A","XvC"))

sp<-seq(from=0.001,to=0.1,by=0.001)
GCV<-numeric(length(sp))
for(i in 1:length(sp)){
    g.m<-gam(Ozone^0.1~s(Temp),sp=sp[i],data=airquality)
    GCV[i]<-g.m$gcv.ubre
}
plot(sp,GCV,type='l')

g.lm<-gam(Ozone^0.1 ~ s(Temp),sp=100000,data=airquality)
g.lm.pred<-predict(g.lm,new) #قlmƓD
mean((g.lm.pred - lm.pred)^2)

######################
## lHf[^: smooth
y18 <- c(1:3, 5, 4, 7:3, 2*(2:5), rep(10, 4))
artdata = data.frame(x=1:18,y=y18)
xx  <- seq(1, length(y18), len = 201)
(s2  <- smooth.spline(artdata)) # cubic spline (B-spline), GCV
(s02  <- smooth.spline(artdata, spar = 0.02)) #spar͐p[^
(s03  <- smooth.spline(artdata, spar = 1))

plot(y18, main = "cubic spline fitting", col.main = 2)
lines(predict(s2, xx), col = 2, lwd=2)
lines(predict(s02, xx), col = 3) 
lines(predict(s03, xx), col = 4) 
legend(14, 3, legend = c("CV", "small","Large"), lty=c(1), col=c(2,3,4),title = "lambda")

plot(y18, main = "cubic spline fitting", col.main = 2)
lines(predict(s2, xx), col = 2)
lines(predict(s03, xx), col = 4) 
legend(14, 3, legend = c("spline", "linear"), lty=c(1), col=c(2,3,4),title = "method")
